﻿/*! Copyright Pulse-Eight Limited 2016 
	This file is licensed to you as part of your ownership of one of our systems.
	You may not reproduce this code in part or entirety without expressed permission of Pulse-Eight Limited.
	
	For licensing terms, please email licensing@pulse-eight.com
	https://www.pulse-eight.com/
*/
var allIRProfiles = [{Id: -1, Name: 'Use Global Default'}];

function updateControlSettings() {
	doServerCall('/System/Features',
		function (data) {
			if (data.CEC === null) {
				$('#cecMissingContainer').show();
				$('#cecContainer').hide();
				return;
			}
			$('#libCECStatus').prop('checked', data.CEC ? 'checked' : '');
			doServerCall('/CEC/AutoPause',
				function(info) {
					$('#autoPauseStatus').prop('checked', info.Result ? 'checked' : '');
				},
				function() {
					$('#autoPauseContainer').hide();
				},
				function(d) {
					if (undefined !== window.Switchery) {
						$.each($('.js-switch'), function (i, v) {
							var sw = new Switchery(v);
						});
					}
				}
			);
		});

	doServerCall('/IR/Details',
		function(data) {
			if (data.Result) {
				doServerCall('/IR/Profiles',
					function(info) {
						$('#IRProfiles').empty();
						$(info.Profiles).each(function (z, v) {
							if (v.Id < 6) {
								if (v.Id != 2) {
									allIRProfiles.push({ Id: v.Id, Name: v.Name });
								}
								var option = $('<option/>', { 'value': v.Id }).text(v.Name);
								if (v.Id == data.Id) {
									option.attr('selected', 'selected');
									if (v.Id == 2) {
										$('#irManageProfileBtn').show();
									}
								}
								$('#IRProfiles').append(option);
							}
						});

						switch (localStorage.getItem('SYSTEM_MODEL')) {
							case MODEL.Modular8:
								$('#Context8Container').show();
								break;
						}

						for (var i = 0; i < 8; i++) {
							updateOutputIRProfile(i);
						}
					});
			}
		});
}


updateOutputIRProfile = function (port) {
	doServerCall('/IR/Details/' + port,
		function (irDetails) {
			$('#OutputProfile' + (port + 1)).empty();
			$(allIRProfiles).each(function (i, v) {
				var option = $('<option/>', { 'value': v.Id }).text(v.Name);
				if (v.Id == irDetails.Id) {
					option.attr('selected', 'selected');
				}
				$('#OutputProfile' + (port + 1)).append(option);
			});
			//Add in bespoke custom profile for this port
			return; //Not implemented yet
			var customPortProfileId = 6 + port;
			var option = $('<option/>', { 'value': customPortProfileId }).text('Custom');
			if (irDetails.Id == customPortProfileId) {
				option.attr('selected', 'selected');
				$('#OutputCustomEditBtn' + (port+1)).show();
			}
			$('#OutputProfile' + (port + 1)).append(option);

		}
	);
}


$(document).ready(function() {
	refreshStatus();
	updateControlSettings();
});

$(document).on('settingsLoaded', function () {
	if (localStorage.getItem('SYSTEM_MODEL') == MODEL.Bronze) {
		$('#autoPauseContainer').hide();
	}
});

$(document).on('change', '#IRProfiles', function (e) {
	if ($('#IRProfiles').val() == 2) {
		$('#irManageProfileBtn').show();
	} else {
		$('#irManageProfileBtn').hide();
	}
	$('#irSaveProfile').show();
});

$(document).on('change', 'select[id^="OutputProfile"]', function (e) {
	var output = $(e.target).attr('Id').replace('OutputProfile', '');
	if ($(e.target).val() == (5 + Number(output))) {
		$('#OutputCustomEditBtn' + output).show();
	}
	$('#OutputIRSave' + output).show();
});

$(document).on('click', 'input[id^="OutputIRSave"]', function(e) {
	var output = $(e.target).attr('Id').replace('OutputIRSave', '');
	doServerPost('/IR/SetProfile/' + (Number(output) - 1),
		{ 'Profile': parseInt($('#OutputProfile' + output).val()) },
		function(data) {
			if (data.Result) {
				displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
				$('#OutputIRSave' + output).hide();
			} else {
				displayBanner(false, data.ErrorMessage);
			}
		});
});

$(document).on('click', 'button[id^="OutputCustomEditBtn"]', function (e) {
	var output = $(e.target).attr('Id').replace('OutputCustomEditBtn', '');
	//TODO
});

$(document).on('click', '#irSaveProfile', function () {
	doServerPost('/IR/SetProfile', 
		{'Profile': parseInt($('#IRProfiles').val())},
		function(data) {
			if (data.Result) {
				displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
				$('#irSaveProfile').hide();
			} else {
				displayBanner(false, data.ErrorMessage);
			}
		});
});

$(document).on('change', '#autoPauseStatus', function () {
	doServerPost('/CEC/AutoPause',
		{ "AutoPause": $('#autoPauseStatus').is(':checked') },
		function (data) {
			if (data.Result) {
				displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
			} else {
				displayBanner(false, data.ErrorMessage);
			}
		});
});

$(document).on('change', '#libCECStatus', function() {
	var ajaxURL = '/CEC/';
	if (!$('#libCECStatus').is(':checked')) {
		ajaxURL += 'Disable';
	} else {
		ajaxURL += 'Enable';
	}
	doServerPost(ajaxURL, {}, function(data) {
		if (data.Result) {
			displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
		} else {
			displayBanner(false, data.ErrorMessage);
		}
	});
});

$(document).on('click', '#irManageProfileBtn', function () {
	window.location.href = '/admin/ir.htm';
})