﻿/*! Copyright Pulse-Eight Limited 2016 
	This file is licensed to you as part of your ownership of one of our systems.
	You may not reproduce this code in part or entirety without expressed permission of Pulse-Eight Limited.
	
	For licensing terms, please email licensing@pulse-eight.com
	http://www.pulse-eight.com/
*/

var originalStatusLEDValue = null;
var originalBacklightLEDValue = null;

function updateFeatureSettings() {
	doServerCall('/System/Features',
			function (data) {
				$('#libCECStatus').val(data.CEC ? 1 : 0);
				if (data.StatusLED) {
					$('#statusLED').val(originalStatusLEDValue = data.StatusLED);
					$('#saveLEDButton, #FrontPanalLabel, #StatusLEDContainer').show();
				}
				if (data.BacklightLED) {
					$('#backlightLED').val(originalBacklightLEDValue = data.BacklightLED);
					$('#saveLEDButton, #FrontPanalLabel, #BacklightLEDContainer').show();
				}
			}
		);
}

$(document).on('click', '#saveLEDButton', function () {
	if ($('#statusLED').val() != originalStatusLEDValue) {
		doServerPost('/System/StatusLED/' + ($('#statusLED').val() == 1 ? "On" : "Off"), {},
			function (data) {
				if (data.Result) {
					displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
				} else {
					displayBanner(false, data.Message);
				}
			});
	}
	if ($('#backlightLED').val() != originalBacklightLEDValue) {
		doServerPost('/System/BacklightLED/' + $('#backlightLED').val(), {},
			function(data) {
				if (data.Result) {
					displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
				} else {
					displayBanner(false, data.Message);
				}
			});
	}
});

$(document).on('click', '#libCECSaveButton', function() {
	var ajaxURL = '/CEC/' + ($('#libCECStatus').val() == 0 ? 'Disable' : 'Enable');
	doServerPost(ajaxURL, {}, function(data) {
		if (data.Result) {
			displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
		} else {
			displayBanner(false, data.ErrorMessage);
		}
	});
});

$().ready(function () {
	refreshStatus();
	updateFeatureSettings();
});