﻿/*! Copyright Pulse-Eight Limited 2014 
	This file is licensed to you as part of your ownership of one of our systems.
	You may not reproduce this code in part or entirety without expressed permission of Pulse-Eight Limited.
	
	For licensing terms, please email licensing@pulse-eight.com
	http://www.pulse-eight.com/
*/

function updateFeatureSettings() {
	doServerCall('/System/Features',
		function (data) {
			if (data.StatusLED) {
				$('#StatusLED').prop('checked', data.StatusLED.toLowerCase() == 'on' ? 'checked' : '');
			} else {
				$('#StatusLEDContainer').hide();
			}
			if (data.BacklightLED) {
				$('#BacklightContainer').show();
				$('#BacklightLED').val(data.BacklightLED.toLowerCase());
				if (undefined !== window.Switchery) {
					$.each($('.js-switch'), function(i, v) {
						var sw = new Switchery(v);
					});
				}
			} else {
				$('#BacklightContainer').hide();
			}
		});
}

$(document).on('change', '#BacklightLED', function () {
	doServerPost('/System/BacklightLED/' + $('#BacklightLED').val(), {},
		function(data) {
			if (data.Result) {
				displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
			} else {
				displayBanner(false, data.Message);
			}
		});
});

$(document).on('change', '#StatusLED', function () {
	doServerPost('/System/StatusLED/' + ($('#StatusLED').is(':checked') ? "On" : "Off"), {},
		function (data) {
			if (data.Result) {
				displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
			} else {
				displayBanner(false, data.Message);
			}
		});
});

$(document).ready(function () {
	refreshStatus();
	updateFeatureSettings();
});