﻿/*! Copyright Pulse-Eight Limited 2016 
	This file is licensed to you as part of your ownership of one of our systems.
	You may not reproduce this code in part or entirety without expressed permission of Pulse-Eight Limited.
	
	For licensing terms, please email licensing@pulse-eight.com
	https://www.pulse-eight.com/
*/

if (typeof String.prototype.startsWith != 'function') {
	// see below for better implementation!
	String.prototype.startsWith = function (str){
		return this.indexOf(str) === 0;
	};
}

function getParameterByName(name) {
	name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
	var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
	return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function fetchCustomIRProfile() {
	doServerCall('/IR/Show/2', function(data) {
		$.each(data, function(i, v) {
			if (i.startsWith('switch_ctx_')) {
				$('#ContextIR' + i.replace('switch_ctx_', '') + 'Value').text(v);
			}
			switch (localStorage.getItem('SYSTEM_MODEL')) {
			case MODEL.Modular8:
				$('#Context8Container').show();
				break;
			}
		});
	});
}

var activeContext = null;

function editContext(port) {
	activeContext = port;
	$('#ContextIREditModal').modal('show');
}

$('#ContextIREditModal').on('shown.bs.modal', function () {
	refreshIRHistory();
});

function useContextCode(hexValue) {
	if (activeContext != null) {
		doServerPost('/IR/SetKey', {
			Profile: 2,
			Code: hexValue,
			InBay: (activeContext - 1)
		},
		function(data) {
			if (data.Result) {
				displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
				fetchCustomIRProfile();
			}
		});
	}
	$('#ContextIREditModal').modal('hide');
	activeContext = null;
}

var refreshIRHistory = function () {
	doServerCall('/IR/History',
		function(data) {
			$('#IRHistory').text('');
			if (data.History && data.History.length) {
				data.History.reverse();
				$.each(data.History, function(i, v) {
					$('#IRHistory').append($('<div/>', { 'class': 'form-group' })
						.append($('<div/>', { 'class': 'col-md-2 control-label' }).text('Port ' + (v.Bay + 1)))
						.append($('<div/>', { 'class': 'col-md-3 control-label' }).text((data.Uptime - v.Time) + ' seconds ago'))
						.append($('<div/>', { 'class': 'col-md-3 control-label' }).text(v.Hex))
						.append($('<div/>', { 'class': 'col-md-4' }).append($('<button/>', { 'class': 'btn btn-wide btn-success', 'onclick': "useContextCode('" + v.Hex + "'); return false;" }).text('Use This Code')))
					);
				});
			} else {
				$('#IRHistory').text('No IR History, press a key to get started');
			}
			if ($('#ContextIREditModal').hasClass('in')) {
				setTimeout(refreshIRHistory, 1000);
			}
		});
}

$(document).ready(function() {
	refreshStatus();
	fetchCustomIRProfile();
});

$(document).on('change', '#IRProfiles', function () {
	$('#irSaveProfile').show();
});

$(document).on('click', '#irSaveProfile', function () {
	doServerPost('/IR/SetProfile', { 'Profile': parseInt($('#IRProfiles').val()) },
		function(data) {
			if (data.Result) {
				displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
				$('#irSaveProfile').hide();
			} else {
				displayBanner(false, data.ErrorMessage);
			}
		});
});