﻿/*! Copyright Pulse-Eight Limited 2016
	This file is licensed to you as part of your ownership of one of our systems.
	You may not reproduce this code in part or entirety without expressed permission of Pulse-Eight Limited.
	
	For licensing terms, please email licensing@pulse-eight.com
	https://www.pulse-eight.com/
*/

var updateInProgress = false;

var refreshHeartBeatInfo = function () {
	doServerCall('/Monitoring/Settings',function (data) {
		if (data.Result) {
			updateInProgress = false;
			$('#SystemUpdateContainer').hide();
			$('#MonitoringDataContainer').show();
			$('#monLastSent').html(new Date(new Date().getTime() - (data.LastContact * 1000)));
			$('#monInstallerId').val(data.InstallerId);
		} else {
			if (data.ErrorMessage == "Update in progress") {
				updateInProgress = true;
				$('#SystemUpdateContainer').show();
				$('#SystemUpdate').html(data.ErrorMessage + ": " + data.Percentage + "% complete");
				$('#MonitoringDataContainer').hide();
				setTimeout(refreshHeartBeatInfo, 500);
			}
		}
	},
	function () {
		if (updateInProgress) {
			$('#SystemUpdate').html("Applying updates... please wait");
		} else {
			displayBanner(false, LANGUAGE_GET_SETTINGS_FAILED);
		}
		setTimeout(refreshHeartBeatInfo, 2000);
	});
};

function doRefresh(hideBanner) {
	doServerCall('/Monitoring/Refresh',
		function (data) {
		    if (data.Result) {
		        if (!hideBanner) {
		            displayBanner(true, LANGUAGE_HB_SENT);
		            setTimeout(refreshHeartBeatInfo, 3000);
		        }
		    } else {
		        if (!hideBanner) {
		            displayBanner(false, LANGUAGE_HB_FORCE_FAILED);
		        }
		    }
		},
		function () {
		    if (!hideBanner) {
		        setTimeout(refreshHeartBeatInfo, 2000);
		        displayBanner(false, LANGUAGE_HB_FORCE_FAILED);
		    }
		});
}

var checkCloudStatus = function() {
    doServerCall('/Cloud/Status',
        function (data) {
            if (data.Result) {
                $('#CloudStatus').html(data.Message);
                if (data.Message == 'Connected') {
                    $('#AlexaSetupLink').show();
                }
                $('#CloudContainer').show();
            }
        },
        function(data) {

        });
}

$(document).ready(function () {
    if ($('#MonitoringDataContainer')) {
        refreshHeartBeatInfo();
    }
    if ($('#CloudContainer')) {
        checkCloudStatus();
    }
});

$(document).on('click', '#monForceUpdateButton', function() {
	doRefresh();
});

$(document).on('change keyup', '#monServerIP, #hpInstallerId', function() {
	if (validateIPaddress($('#monServerIP').val())) {
		$('#hpSaveSettings').show();
	} else {
		$('#hpSaveSettings').hide();
	}
});

$(document).on('click submit', '#monSaveSettingsButton, #monitoringContainer', function () {
	doServerPost('/Monitoring/SaveSettings', { monInstallerId: $('#monInstallerId').val() },
		function(data) {
			if (data.Result) {
				displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
				doRefresh();
			} else {
				displayBanner(false, data.ErrorMessage);
			}
		});
});