﻿var updatePDUDetails = function() {
	$.ajax({
		url: MATRIX_URL + '/power/settings',
		success: function (data) {
			$('#pduContainer').show();
			//if (data.Result) {
			setStatus($('#PDUStatus'), data.State == 2 ? 0 : 2, data.StateString);
			$('#PDUStatus').text(data.StateString);
			$('#pduIPAddress').val(data.Address);
			//} else {
			//	displayBanner(false, data.ErrorMessage);
			//}
			if (data.State == 1 || data.State == 3) {
				//setTimeout(updatePDUDetails, 1000);
				$('#pduPortDetailsContainer').hide();
				$('#pduDetailsContainer').hide();
			}

			if (data.State == 2) {
				updatePDUPorts();
				$('#pduPortDetailsContainer').show();
				$('#pduDetailsContainer').show();
			}
		},
		error: function () {
			//Maybe not supported?
			//displayBanner(false, LANGUAGE_GET_SETTINGS_FAILED);
		}
	});
}

var bCanManagePower = null;

function canManagePower() {
	if (bCanManagePower !== null) {
		return bCanManagePower;
	}

	$.ajax({
		url: MATRIX_URL + '/power/settings',
		success: function (data) {
			bCanManagePower = data.State == 2;
		},
		error: function () {
			bCanManagePower = null;
			return false;
		},
		complete: function() {
			$(document).trigger('pduStateUpdated');
		}
	});
}

var refreshPDU = function() {
    updatePDUPorts();
    updatePDUDetails();
    setTimeout(refreshPDU, 15000);
}

var updatePDUPorts = function () {
	for (let i = 0; i < 8; i++) {
		fetchPDUPortDetails(i);
	}
}

var fetchPDUPortDetails = function(port) {
	$.ajax({
		url: MATRIX_URL + '/power/' + port,
		success: function (data) {
			if (port == 0) {
				$('#pdu-details')
				.empty()
				.append('<td>' + (data.Power !== undefined ? data.Power.toFixed(2) : '') + 'W</td>')
				.append('<td>' + (data.Current !== undefined ? data.Current.toFixed(2) : '') + 'A</td>')
				.append('<td>' + (data.Voltage !== undefined ? data.Voltage.toFixed(2) : '') + 'V</td>')
				.append('<td>' + (data.Dissipation !== undefined ? data.Dissipation.toFixed(2) : '') + 'W</td>')
				.append('<td>' + (data.Frequency !== undefined ? data.Frequency.toFixed(2) : '') + 'Hz</td>');
			}
			$('#pduPort-' + port)
				.empty()
				.append('<td>' + (port+1) + '</td>')
				.append('<td>' + data.StateString + '</td>');
			var options = '<td>';
			switch(data.State) {
				case 0:
					options += '<a href="#" onclick="setPortState(' + port + ', \'on\', true)" class="label label-success">Turn On</a>';
					break;
				case 1:
					options += '<a href="#" onclick="setPortState(' + port + ', \'off\', true)" class="label label-danger">Turn Off</a> <a href="#" onclick="rebootPort(' + port + ')" class="label label-warning">Reboot</a>';
					break;
			}
			options += '</td>';
			$('#pduPort-' + port).append(options);
		}
	});
}

var setPortState = function (port, mode, reload) {
	$.ajax({
		url: MATRIX_URL + '/power/' + mode + '/' + port,
		success: function(data) {
			if (data.Result && reload) {
				setTimeout(updatePDUDetails, 1000);
			}
		}
	});
}

function rebootPort(port) {
	setPortState(port, 'reboot', true);
	setTimeout(updatePDUDetails, 11000);
//	$.ajax({
//		url: MATRIX_URL + '/power/reboot/' + port,
//		success: function (data) {
//			if (data.Result) {
//				setTimeout(updatePDUDetails, 2500);
//				setTimeout(updatePDUDetails, 12500);
//			}
//		}
//	});
}

$('#pduSaveIPBtn').on('click', function() {
	$.ajax({
		url: MATRIX_URL + '/power/settings',
		type: 'POST',
		data: JSON.stringify({
			Address: $('#pduIPAddress').val()
		}),
		success: function(data) {
			console.log(data);
			setTimeout(updatePDUDetails, 1000);
		}
	});
});

$('#pduIPAddress').on('change keydown', function() {
	$('#pduSaveIPBtn').css('visibility', 'visible');
});

$(document).ready(function () {
	if (window.PDU_MANAGE === true) {
	    refreshPDU();
	}
});
