﻿/*! Copyright Pulse-Eight Limited 2016
	This file is licensed to you as part of your ownership of one of our systems.
	You may not reproduce this code in part or entirety without expressed permission of Pulse-Eight Limited.
	
	For licensing terms, please email licensing@pulse-eight.com
	https://www.pulse-eight.com/
*/

function getVersion() {
	doServerCall('/System/GetVersion',
		function(data) {
			$('#softwareVersion').val(data.CurrentVersion);
			$('#hardwareVersion').val(data.HardwareVersion);
			if (data.NewVersionAvailable) {
				$('#new-software-version').html(data.NewVersion);
				$('#newVersionContainer').show();
				$('#softwareVersion').addClass('disabled-yellow');
			} else {
				$('#softwareVersion').addClass('disabled-green');
			}
			$('#automaticUpdates').val(data.AutomaticUpdates).slider('refresh');
			if (data.InstallerControlledUpdates != undefined && data.InstallerControlledUpdates != null) {
				$('#installerControlled').val(data.InstallerControlledUpdates).slider('refresh');
			} else {
				$('#installerControlledContainer').hide();
			}
		});
}

$(document).on('change', '#installerControlled, #automaticUpdates', function() {
	$.post(MATRIX_URL + '/System/SaveUpdateSettings', { automaticUpdates: $('#automaticUpdates').val(), installerControlledUpdates: $('#installerControlled').val() }, function (data) {
		if (data.Result) {
			displayBanner(true, LANGUAGE_SETTINGS_SAVED_SUCCESS);
		} else {
			displayBanner(false, LANGUAGE_SETTINGS_SAVED_FAILED);
		}
	});
});

$(document).on('click', '#updateSoftwareButton', function () {
	$.post(MATRIX_URL + '/System/Update', null, function (data) {
		if (data.Result) {
			$('body').html('<div id="updateInProgress">System is updating, please wait...</div>');
			setTimeout(function() {
				window.location.href = '/';
			}, 20000);
		} else {
			displayBanner(false, 'Error: Update failed, please try later');
		}
	});
});

$(document).on('pagebeforeshow', '#updatePage', function () {
	refreshStatus();
	$('#automaticUpdatesLabel, #installerControlledLabel').removeClass('ui-slider');
	getVersion();
});